      subroutine core_data(AA)
      use mod_dolo
      IMPLICIT REAL*8(A-H,O-X,Z),logical*1(y)
      character(len_datlist) AA
      character(3) ccor
      character(11) label1,labelt(100)
      character(4) atom1,a1
      character(200) bas1
      character label0
      character(7) occup
      character(600) aa0
      print*,'entree coredata'
!
!---------------------------------------------------------------
! increment ncor (avoids orbitals with the same name)
!---------------------------------------------------------------
!
      ncor=ncor+1
      print*,'ncor',ncor
      write(ccor,'(i3)') ncor
      ccor=adjustl(ccor)
!
!---------------------------------------------------------------
! begin print
!---------------------------------------------------------------
!
      print'(/,80a1)',('*',k=1,80)
      print'(a,/)',trim(AA)
      print*,'Liaisons generees'
!
!---------------------------------------------------------------
! transform LO into namelist
!---------------------------------------------------------------
!
      labelt=' '
      call namela(AA,LABELT,'LABEL')
      l=len_trim(AA)
      call repl(AA," ","ATOM1='",yrepl)
      call repl(AA,' ',"',BAS1='",yrepl)
      call repl(AA,'LABEL',',LABEL',yrepl)
      l=len_trim(AA)+1
      AA(l:l)=''','
!
!---------------------------------------------------------------
! transform 2P orbitals
!---------------------------------------------------------------
!
      yrepl=.true.
      do while(yrepl)
         call repl(AA,'2P(1)',"2PX(1) 2PY(1) 2PZ(1)",yrepl)
      enddo
!
!---------------------------------------------------------------
! read atom1, bas1 and nlabel
!---------------------------------------------------------------
!
      call namela(AA,ATOM1,'ATOM1')
      call namela(AA,BAS1,'BAS1')
      do k=1,100
         if(labelt(k)==' ') then
            nlabel=k-1
            exit
         endif
      enddo
      !print*,atom1
      !print*,bas1
!
!---------------------------------------------------------------
! search all corresponding atoms in the list atom(:)
! build one data line for each atom
!---------------------------------------------------------------
!
      l1=len_trim(atom1)
      atom1(l1:l1)=' '
      do i=1,natom
         a1=atom(i)
         call suppnum(a1)
         if(a1/=atom1) cycle
         mult=mult1(i)
         write(occup,'(a2,i1,a3)') ' (',mult,' 0)'
         label0='C'
         do ii=1,nlabel
            call maj(labelt(ii),11)
            call failabel0(labelt(ii),label0,atom(i),'core')
            if(label0/='C') exit
         enddo
         aa0=' '
         if(ncor>99) then
            write(aa0,'(a)')
     *      label0//'_CO.'//trim(atom(i))//'.'//trim(ccor)//' '//
     *      trim(atom(i))//' '//trim(bas1)//
     *      occup
         else
            write(aa0,'(a)')
     *      label0//'_COR.'//trim(atom(i))//'.'//trim(ccor)//' '//
     *      trim(atom(i))//' '//trim(bas1)//
     *      occup
         endif
         print*,'ecriture 94'
         write(94,'(a)') trim(aa0)
         write(6,'(a)') trim(aa0)
      enddo
      return
      end
