subroutine calc_occup_par_proj
use lewis_module
use mod_script
use mod_lirorb
!
!=================================================================
! Projection sur des OM de reference SCF ou CASSCF
!=================================================================
!
implicit real*8 (a-h,o-x,z),logical*1(y)
allocatable orbscf(:,:),occscf(:)
yw=.false.

!
!=============================================================
! Lecture des orbitales de reference
!=============================================================
!
open(25,file=scforbin,status='old')
call lirorb(scforbin,norb2,nsym2,isym2,26,25)

!=================================================================
allocate(orbscf(norb,norb))
orbscf=0.d0
allocate(occscf(norb))
ifin=0
do is=1,nsym
   rewind 26
   ideb=ifin+1
   ifin=ifin+isym(is)
   norbs=isym(is)
   if(yw)print*,'projection is,norbs',is,norbs
   do k=1,is-1
      read(26)
   enddo
   read(26) orbscf(ideb:ifin,ideb:ifin)
   do k=1,nsym-1
      read(26)
   enddo
   read(26) occscf(ideb:ifin)
   n2=fermi(is)
enddo

!
!=============================================================
! orbitales de reference exprimees dans la base des OA non sym
!=============================================================
!
if(mprint(1)==1) &
print*,'matrice des OM de reference dans OA sym)'
if(mprint(1)==1) &
call scriptol2(orbscf,norb,norb,norb,norb,label0//'  ', &
(/(i,i=1,norb)/),(/('                    ',i=1,norb)/),occ)
 orbscf=matmul(pass,orbscf)
if(mprint(1)==1) &
print*,'matrice des OM de reference dans OA non sym)'
if(mprint(1)==1) &
call scriptol2(orbscf,norb,norb,norb,norb,label0//'  ', &
(/(i,i=1,norb)/),(/('                    ',i=1,norb)/),occ)

!
!=============================================================
! projection des occupées
!=============================================================
!
close(25)
close(26)
return
end


